%define root	crack

%define major		2
%define libname		%mklibname %{root} %{major}
%define develname	%mklibname %root -d

Summary:	A password-checking library
Name:		cracklib
Version:	2.9.6
Release:	%mkrel 1
Group:		System/Libraries
License:	LGPLv2
URL:		http://sourceforge.net/projects/cracklib/
Source0:	https://github.com/cracklib/cracklib/releases/download/cracklib-%{version}/cracklib-%{version}.tar.xz
Source1:        https://github.com/cracklib/cracklib/releases/download/cracklib-%{version}/cracklib-words-%{version}.gz

# No upstream source for this, just words missing from the current cracklib-words
Source10:	missing-words.gz

Patch0:		cracklib-2.8.22-fix-python-path.patch
Patch1:		cracklib-2.9.1-inttypes.patch
Patch2:		cracklib-2.9.6-cve-2016-6318.patch
Patch3:		cracklib-2.9.5-overflow-processing-long-words.patch
BuildRequires:	gettext-devel
BuildRequires:	zlib-devel

%description
CrackLib tests passwords to determine whether they match certain
security-oriented characteristics. You can use CrackLib to stop
users from choosing passwords which would be easy to guess. CrackLib
performs certain tests: 

* It tries to generate words from a username and gecos entry and 
  checks those words against the password;
* It checks for simplistic patterns in passwords;
* It checks for the password in a dictionary.

CrackLib is actually a library containing a particular
C function which is used to check the password, as well as
other C functions. CrackLib is not a replacement for a passwd
program; it must be used in conjunction with an existing passwd
program.

Install the cracklib package if you need a program to check users'
passwords to see if they are at least minimally secure. If you
install CrackLib, you'll also want to install the cracklib-dicts
package.

%package -n	%{libname}
Summary:	A password-checking library
Group:		System/Libraries
Obsoletes:	cracklib < %{version}-%{release}

%description -n %{libname}
CrackLib tests passwords to determine whether they match certain
security-oriented characteristics.

%package -n	%{libname}-python
Summary:	A password-checking library
Group:		System/Libraries
Obsoletes:	cracklib-python < %{version}-%{release}
BuildRequires:	python
BuildRequires:	python-devel

%description -n %{libname}-python
CrackLib tests passwords to determine whether they match certain
security-oriented characteristics.

%package	dicts
Summary:	The standard CrackLib dictionaries
Group:		System/Libraries

%description	dicts
The cracklib-dicts package includes the CrackLib dictionaries.
CrackLib will need to use the dictionary appropriate to your system,
which is normally put in /usr/share/dict/words.  Cracklib-dicts also contains
the utilities necessary for the creation of new dictionaries.

If you are installing CrackLib, you should also install cracklib-dicts.

%package -n	%{develname}
Summary:	Cracklib link library & header file
Group:		Development/Libraries
Provides:	lib%{root}-devel = %{version}-%{release}
Provides:	%{root}lib-devel = %{version}-%{release}
Requires:	%{libname} = %{version}
Obsoletes:	cracklib-devel < %{version}-%{release}
Obsoletes:	%{mklibname crack 2 -d} < %{version}-%{release}

%description -n	%{develname}
The cracklib devel package include the needed library link and
header files for development.

%prep
%setup -q
%patch0 -p0
cp -p lib/packer.h lib/packer.h.in
%patch1 -p1 -b .inttypes
%patch2 -p1 -b .CVE-2016-6318
%patch3 -p1 -b .overflow

for dict in %{SOURCE10} %{SOURCE1}
do
    cp ${dict} dicts/
done

%build
autoreconf -vfi
%configure2_5x --libdir=/%{_lib}
%make

%install
rm -rf %buildroot
%makeinstall_std

chmod 0755 ./util/cracklib-format ./util/cracklib-packer
./util/cracklib-format dicts/* | ./util/cracklib-packer %{buildroot}%{_datadir}/cracklib/pw_dict

ln -s cracklib-format %{buildroot}%{_sbindir}/mkdict
ln -s cracklib-packer %{buildroot}%{_sbindir}/packer

ln -s %{_datadir}/cracklib/pw_dict.hwm %{buildroot}%{_libdir}/cracklib_dict.hwm
ln -s %{_datadir}/cracklib/pw_dict.pwd %{buildroot}%{_libdir}/cracklib_dict.pwd
ln -s %{_datadir}/cracklib/pw_dict.pwi %{buildroot}%{_libdir}/cracklib_dict.pwi

install -m644 lib/packer.h %{buildroot}%{_includedir}/

%find_lang %{name}

%files -n %{libname}
/%{_lib}/*.so.%{major}*


%files -n %{libname}-python
%{py_platsitedir}/cracklib*
%{py_platsitedir}/_cracklib*
%{py_platsitedir}/test_cracklib*

%files -f %{name}.lang
%doc AUTHORS NEWS README*

%files -n %{develname}
%{_includedir}/*
/%{_lib}/*.so
/%{_lib}/*.*a

%files dicts
%{_sbindir}/*
%{_datadir}/%{name}
%{_libdir}/cracklib_dict.*


%changelog
* Thu Jun 07 2018 adrianomorselli <adrianomorselli> 2.9.6-1uplos2018
- update